package ru.nsu.ccfit.boldyrev.minesweeper.gui;

import java.awt.Color;
import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.GridLayout;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

public class SwingNewGameDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private JLabel jLabel0;
	private JTextField jTextField0;
	private JLabel jLabel1;
	private JTextField jTextField1;
	private JPanel jPanel0;
	private JLabel jLabel2;
	private JTextField jTextField2;
	private JButton jButton0;
	private JButton jButton1;


	public SwingNewGameDialog() {
		initComponents();
	}

	public SwingNewGameDialog(Frame parent) {
		super(parent);
		initComponents();
	}

	public SwingNewGameDialog(Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
	}

	public SwingNewGameDialog(Frame parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingNewGameDialog(Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		initComponents();
	}

	public SwingNewGameDialog(Frame parent, String title, boolean modal,
			GraphicsConfiguration arg) {
		super(parent, title, modal, arg);
		initComponents();
	}

	public SwingNewGameDialog(Dialog parent) {
		super(parent);
		initComponents();
	}

	public SwingNewGameDialog(Dialog parent, boolean modal) {
		super(parent, modal);
		initComponents();
	}

	public SwingNewGameDialog(Dialog parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingNewGameDialog(Dialog parent, String title, boolean modal) {
		super(parent, title, modal);
		initComponents();
	}

	public SwingNewGameDialog(Dialog parent, String title, boolean modal,
			GraphicsConfiguration arg) {
		super(parent, title, modal, arg);
		initComponents();
	}

	public SwingNewGameDialog(Window parent) {
		super(parent);
		initComponents();
	}

	public SwingNewGameDialog(Window parent, ModalityType modalityType) {
		super(parent, modalityType);
		initComponents();
	}

	public SwingNewGameDialog(Window parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingNewGameDialog(Window parent, String title,
			ModalityType modalityType) {
		super(parent, title, modalityType);
		initComponents();
	}

	public SwingNewGameDialog(Window parent, String title,
			ModalityType modalityType, GraphicsConfiguration arg) {
		super(parent, title, modalityType, arg);
		initComponents();
	}

	private void initComponents() {
		setTitle("New Game");
		setFont(new Font("Dialog", Font.PLAIN, 12));
		setBackground(Color.white);
		setLocationRelativeTo(getParent());
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setResizable(false);
		setModal(true);
		setForeground(Color.black);
		//setLayout(new GroupLayout());
		add(getJPanel0());//, new Constraints(new Leading(10, 283, 10, 10), new Bilateral(11, 11, 98)));
		setSize(303, 120);
	}

	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Cancel");
			jButton1.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent event) {
					jButton1ActionActionPerformed(event);
				}
			});
		}
		return jButton1;
	}

	private JButton getJButton0() {
		if (jButton0 == null) {
			jButton0 = new JButton();
			jButton0.setText("Start game");
			jButton0.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent event) {
					jButton0ActionActionPerformed(event);
				}
			});
		}
		return jButton0;
	}

	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField2.setText("10");
		}
		return jTextField2;
	}

	private JLabel getJLabel2() {
		if (jLabel2 == null) {
			jLabel2 = new JLabel();
			jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
			jLabel2.setText("Number of mines:");
		}
		return jLabel2;
	}

	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField1.setText("9");
		}
		return jTextField1;
	}

	private JLabel getJLabel1() {
		if (jLabel1 == null) {
			jLabel1 = new JLabel();
			jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
			jLabel1.setText("Height:");
		}
		return jLabel1;
	}

	private JTextField getJTextField0() {
		if (jTextField0 == null) {
			jTextField0 = new JTextField();
			jTextField0.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField0.setText("9");
		}
		return jTextField0;
	}

	private JLabel getJLabel0() {
		if (jLabel0 == null) {
			jLabel0 = new JLabel();
			jLabel0.setHorizontalAlignment(SwingConstants.RIGHT);
			jLabel0.setText("Width:");
		}
		return jLabel0;
	}

	private JPanel getJPanel0() {
		if (jPanel0 == null) {
			jPanel0 = new JPanel();
			jPanel0.setLayout(new GridLayout(4, 2, 10, 2));
			jPanel0.add(getJLabel0());
			jPanel0.add(getJTextField0());
			jPanel0.add(getJLabel1());
			jPanel0.add(getJTextField1());
			jPanel0.add(getJLabel2());
			jPanel0.add(getJTextField2());
			jPanel0.add(getJButton0());
			jPanel0.add(getJButton1());
		}
		return jPanel0;
	}

	private void jButton1ActionActionPerformed(ActionEvent event) {
		this.dispose();
	}

	private void jButton0ActionActionPerformed(ActionEvent event) {
		if (this.getParent() != null && this.getParent().getClass().isAssignableFrom(SwingView.class)) {
			SwingView view = (SwingView) this.getParent();
			view.startNewGame(Integer.valueOf(getJTextField0().getText()), Integer.valueOf(getJTextField1().getText()), Integer.valueOf(getJTextField2().getText()));
		}
		this.dispose();
	}
}
