package ru.nsu.ccfit.boldyrev.minesweeper.gui;

import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Window;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import ru.nsu.ccfit.boldyrev.minesweeper.Controller;
import ru.nsu.ccfit.boldyrev.minesweeper.Controller.Record;

public class SwingRecordsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private JPanel jPanel0;
	private JLabel jLabel0;
	private JList jList0;
	private JScrollPane jScrollPane0;

	public SwingRecordsDialog() {
		initComponents();
	}

	public SwingRecordsDialog(Frame parent) {
		super(parent);
		initComponents();
	}

	public SwingRecordsDialog(Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
	}

	public SwingRecordsDialog(Frame parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingRecordsDialog(Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		initComponents();
	}

	public SwingRecordsDialog(Frame parent, String title, boolean modal,
			GraphicsConfiguration arg) {
		super(parent, title, modal, arg);
		initComponents();
	}

	public SwingRecordsDialog(Dialog parent) {
		super(parent);
		initComponents();
	}

	public SwingRecordsDialog(Dialog parent, boolean modal) {
		super(parent, modal);
		initComponents();
	}

	public SwingRecordsDialog(Dialog parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingRecordsDialog(Dialog parent, String title, boolean modal) {
		super(parent, title, modal);
		initComponents();
	}

	public SwingRecordsDialog(Dialog parent, String title, boolean modal,
			GraphicsConfiguration arg) {
		super(parent, title, modal, arg);
		initComponents();
	}

	public SwingRecordsDialog(Window parent) {
		super(parent);
		initComponents();
	}

	public SwingRecordsDialog(Window parent, ModalityType modalityType) {
		super(parent, modalityType);
		initComponents();
	}

	public SwingRecordsDialog(Window parent, String title) {
		super(parent, title);
		initComponents();
	}

	public SwingRecordsDialog(Window parent, String title,
			ModalityType modalityType) {
		super(parent, title, modalityType);
		initComponents();
	}

	public SwingRecordsDialog(Window parent, String title,
			ModalityType modalityType, GraphicsConfiguration arg) {
		super(parent, title, modalityType, arg);
		initComponents();
	}

	private void initComponents() {
		setFont(new Font("Dialog", Font.PLAIN, 12));
		setBackground(Color.white);
		setForeground(Color.black);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setLayout(new CardLayout());
		add(getJPanel0(), "jPanel0");
		setSize(500, 414);
		setResizable(false);
		setLocationRelativeTo(getParent());
	}

	private JPanel getJPanel0() {
		if (jPanel0 == null) {
			jPanel0 = new JPanel();
			jPanel0.setLayout(new GridBagLayout());

			GridBagConstraints c = new GridBagConstraints();
			c.fill = GridBagConstraints.HORIZONTAL;
			c.gridx = 0;
			c.gridy = 0;
			c.anchor = GridBagConstraints.NORTH;
			c.gridheight = 1;
			c.gridwidth = GridBagConstraints.REMAINDER;
			c.weightx = 1.0;
			c.ipadx = 100;

			jPanel0.add(getJLabel0(), c);
			c.gridy = 1;
			c.gridheight = GridBagConstraints.REMAINDER;
			jPanel0.add(getJList0(), c);
		}
		return jPanel0;
	}

	private JScrollPane getJScrollPane0() {
		if (jScrollPane0 == null) {
			jScrollPane0 = new JScrollPane();
			jScrollPane0.setViewportView(getJList0());
		}
		return jScrollPane0;
	}

	private JList getJList0() {
		if (jList0 == null) {
			jList0 = new JList();
			DefaultListModel listModel = new DefaultListModel();
			// TODO
			if (getParent() != null && getParent().getClass().isAssignableFrom(SwingView.class)) {
				Controller con = (Controller) ((SwingView)getParent()).getController();
				ArrayList<Record> records = con.getRecordsTable();
				for (Record r : records) {
					String line = r.getName();
					line += " (" + r.getWidth() + "x" + r.getHeight() + ", " + r.getNumberOfMines() + ")";
					line += " --- " + r.getTime() + " sec.";
					listModel.addElement(line);
				}
			}
			jList0.setModel(listModel);
			jList0.setMinimumSize(new Dimension(28, 400));
			jList0.setMaximumSize(new Dimension(28, 400));
		}
		return jList0;
	}

	private JLabel getJLabel0() {
		if (jLabel0 == null) {
			jLabel0 = new JLabel();
			jLabel0.setText("Records Table");
		}
		return jLabel0;
	}

}
